

%evaluate inverse of share function using blp contraction mapping (cmap.m)
function out=deltafunc(sigmaguess,s,xzeta,x,zetas,delta_init,tol,maxiter)

deltaold=cmap(delta_init,s,xzeta,sigmaguess);

for i=1:maxiter
  deltanew=cmap(deltaold,s,xzeta,sigmaguess);
  
  if sum((deltanew-deltaold).^2)<=tol, break, end
  
  deltaold=deltanew;
end

delta=deltanew;

%calculate derivative for second argument
J=length(s);
ns=length(xzeta(1,:));

szeta=exp(delta*ones(1,ns)+xzeta*sigmaguess) ...
    ./(ones(J,1)*sum(exp(delta*ones(1,ns)+xzeta*sigmaguess),1)+1);

dsddelta=diag(mean(szeta,2))-szeta*szeta'/ns;


dsdsigma=mean(((ones(J,1)*zetas').*szeta).*(x*ones(1,ns)-ones(J,1)*sum(x*ones(1,ns).*szeta,1)),2);


out=[deltanew,-inv(dsddelta)*dsdsigma];

