

%estimate of linear parameters for a given sigma (almost same as gmm_obj code, but
%different output)
%  - second output is residuals
function [est_out,resid_out]=linparam_est(sigmaval,s,market,xzeta_all,x,zetas,X,Z,W,N,tol,maxiter)


deltavals=[];
for imarket=1:N
  delta_i=deltafunc(sigmaval,s(market==imarket),xzeta_all(market==imarket,:),x(market==imarket),zetas,ones(length(s(market==imarket)),1),tol,maxiter);
  
  deltavals=[deltavals;delta_i(:,1)];
end

est_out=ivreg(deltavals,X,Z,W);
resid_out=deltavals-X*est_out;

