

%BLP contraction mapping on delta, as a function of guess for sigma (sigmaguess) uses shares from data set (s_data) 
function out=cmap(delta,s_data,xzeta,sigmaguess)

J=length(s_data);
ns=length(xzeta(1,:));

szeta=exp(delta*ones(1,ns)+xzeta*sigmaguess) ...
    ./(ones(J,1)*sum(exp(delta*ones(1,ns)+xzeta*sigmaguess),1)+1);
s_guess=mean(szeta,2);

out=delta+log(s_data)-log(s_guess);

